<?php
/*
###############################################################################
# Name: mongo_db_inc.php
# Developed By: The Uniform Server Development Team
# Modified Last By: Mike Gleaves (Ric) 
# Web: http://www.uniformserver.com
# V1.0.0 20-7-2010
###############################################################################

# open_cmd_window()                 - Opens a command window in bin folder
# set_mongo_port_no_auth($new_port) - Set port no authentication configuration file 
# get_mongo_port_no_auth()          - Get port no authentication configuration file 

# start_mongo_no_auth()             - Start Mongo server no authentication
# stop_mongo_no_auth()              - Stop Mongo server no authentication
# client_no_auth()                  - cmd window + client No Auth 

# mongodb_running()      - Check MongoDB server returns true if running
# mongo_client_running() - Check Mongo client returns true if running

*/

$path_array      = explode("\\mongodb_1",getcwd());          // Split at folder usr
$mongo_base      = $path_array[0];                           // find drive letter and any sub-folders 
$mongo_base_f    = preg_replace('/\\\/','/', $mongo_base);   // Replace \ with /

//=== FOLDERS ===
define("MONGO_BIN",   "$mongo_base_f/mongodb_1/bin");        // Binaries for MongoDB

//=== FILES ===
define("INFO_TXT",           "$mongo_base_f/mongodb_1/control/read_me.txt"); // Information file
define("NO_NAG_TXT",         "$mongo_base_f/mongodb_1/control/no_nag.txt");  // Dummy file
define("CONFIG_NO_AUTH_F",   "$mongo_base_f/mongodb_1/bin/config_no_auth.ini"); 
define("UNISERV_EXE",        "$mongo_base_f/mongodb_1/bin/uniserv.exe"); // Utility 
define("UNISERV_EXE_B",      $mongo_base.'\mongodb_1\bin\uniserv.exe');  // Utility 
define("MON_PSKILL_EXE",     "$mongo_base_f/mongodb_1/bin/pskill.exe");  // Utility 

//=== Open a command window ===================================================
// Opem a cmd window in bin folder 
function open_cmd_window(){
  $return_wd = getcwd();                    // Save current wd 
  chdir(MONGO_BIN);                         // Change wd to Mongo Bin

       $base = preg_replace('/\//','\\', MONGO_BIN); // Replace / with \
       $cmd1 = "start  ";
       $cmd2 = "\"UNIFORM SERVER Mongo Command Line\" ";
       $cmd3 = "cmd.exe /k \"COLOR B0 && cls &&dir\"";
       $cmd  = $cmd1.$cmd2.$cmd3;
       pclose(popen($cmd,'r'));             // Start a new process ignore output  
 
  chdir($return_wd);                        // Restore original wd
}
//=============================================== END Open a command window ===

// === Set Mongo port No Auth =================================================
function set_mongo_port_no_auth($new_port){
 $new_line = "port    = ".$new_port."                 # Port to use\r\n";

 if ($filearray=file(CONFIG_NO_AUTH_F)) {             // read file into array
    foreach ($filearray as $txt) {                    // scan array for port
//      if(preg_match("/^\s*port\s*=\s*(\d+)/", $txt)){ // test for match 
if(preg_match("/\"user\"[ ]*:[ ]*\"(.*)\"[ ]*,/", $txt)){ // test for match 

        $new_array[] = $new_line;                     // found add new line 
      }
      else{                                           // No match
        $new_array[] = $txt;                          // Save original line
      }
    }
 }
 $str = implode($new_array);                   // Convert array to string
 file_put_contents(CONFIG_NO_AUTH_F,$str);     // Save to file
}
// ============================================ END Set Mongo port No Auth ====

// === Get Mongo port No Auth =================================================
function get_mongo_port_no_auth(){
  if ($filearray=file(CONFIG_NO_AUTH_F)) {   // read file into array
    foreach ($filearray as $txt) {           // scan array for port
 
      if(preg_match("/^\s*port\s*=\s*(\d+)/", $txt,$match)){ // test save $match 
       $mongo_port =  $match[1];             // match found save port number 
       break;                                // give up nothing else to do
      }
    }
  }
  else {                                     // failed to read file
    echo "Cannot read the file";
  }
  return $mongo_port;
}
// ============================================ END Get Mongo port No Auth ====

//=== Start Mongo No Auth =====================================================
// Start mongo server. Uses uniserv.exe to detatch hidden process

function start_mongo_no_auth(){
  $return_wd = getcwd();                    // Save current wd 
  chdir(MONGO_BIN);                         // Change wd to Mongo Bin
 
  // Build command line
  $cmd1 = "start ".UNISERV_EXE." \"";
  $cmd2 = "mongod.exe ";
  $cmd3 = "-f ".CONFIG_NO_AUTH_F."\"";
  $cmd=$cmd1.$cmd2.$cmd3;
  //print $cmd; // Test code

  exec($cmd,$dummy,$return);    // Run command 
  chdir($return_wd);           // Restore original wd
}
//================================================= END Start Mongo No Auth ===

//=== Stopt Mongo No Auth =====================================================
// Stop mongo server. Uses uniserv.exe to detatch hidden process

function stop_mongo_no_auth(){
  $port = get_mongo_port_no_auth();         // Get port from config
  $return_wd = getcwd();                    // Save current wd 
  chdir(MONGO_BIN);                         // Change wd to Mongo Bin

  // Build command line
  $cmd1 = "start ".UNISERV_EXE_B." \"";
  $cmd2 = "mongo.exe ";
  $cmd3 = "--port $port ";
  $cmd4 = 'admin --eval \"db.shutdownServer()\"';
  $cmd5 = "\"";
  $cmd=$cmd1.$cmd2.$cmd3.$cmd4.$cmd5;
  //print $cmd; // Test code

  exec($cmd,$dummy,$return);    // Run command 
  chdir($return_wd);            // Restore original wd
}
//================================================== END Stop Mongo No Auth ===

//=== Open a client window No Auth ============================================
// Opem a cmd window in bin folder and runs Mongo-client 
function client_no_auth(){
  $port = get_mongo_port_no_auth();         // Get port from config
  $return_wd = getcwd();                    // Save current wd 
  chdir(MONGO_BIN);                         // Change wd to Mongo Bin

  $cmdx = "mongo.exe  --port $port admin";

       $base = preg_replace('/\//','\\', MONGO_BIN); // Replace / with \
       $cmd1 = "start  ";
       $cmd2 = "\"UNIFORM SERVER Mongo Client No Auth\" ";
       $cmd3 = "cmd.exe /k \"COLOR B0 && cls && $cmdx\"";
       $cmd  = $cmd1.$cmd2.$cmd3;
       pclose(popen($cmd,'r'));             // Start a new process ignore output  
 
  chdir($return_wd);                        // Restore original wd
}
//======================================== END Open a client window No Auth ===

//=== Is MongoDB running ======================================================
function mongodb_running(){
  $mongo_exe = "mongod.exe";   

  $cmd = MON_PSKILL_EXE." $mongo_exe";  // command line to be run  
  exec($cmd,$dummy,$return);            // 0=running 1=not-running 

  if($return == 0){                     // Check return value
   return true;                         // MongoDB is running
  }
  else{
   return false;                        // MongoDB not running
 }
}
//================================================= END Is MongoDB running ====

//=== Is Mongo Client running =================================================
function mongo_client_running(){
  $mongo_exe = "mongo.exe";   

  $cmd = MON_PSKILL_EXE." $mongo_exe";  // command line to be run  
  exec($cmd,$dummy,$return);            // 0=running 1=not-running 

  if($return == 0){                     // Check return value
   return true;                         // Mongo client is running
  }
  else{
   return false;                        // Mongo client not running
 }
}
//============================================ END Is Mongo Client running ====

?>